var bPrefs = null;
var popupOn = false;

// Start prefs service
function bGetPrefs() {
  try {
    var prefsService = Components.classes["@mozilla.org/preferences-service;1"];
    if (prefsService)
		prefsService = prefsService.getService();
    if (prefsService)
		bPrefs = prefsService.QueryInterface(Components.interfaces.nsIPrefBranch);

    if (!bPrefs)
		dump("failed to get prefs service!\n");
  }
  catch(ex) { dump("failed to get prefs service!\n"); }
}

function deleteClose() {
    MsgDeleteMessageFromMessageWindow(false,true);
    window.close();
}

function forwardClose() {
    MsgForwardMessage(null);
    window.close();
}

function replyClose() {
    MsgReplyMessage(null);
    window.close();
}

function replyAllClose() {
    MsgReplyToAllMessage(null);
    window.close();
}

function realNextMessageWindow() {
    performNavigation(nsMsgNavigationType.nextMessage);
}

function realPreviousMessageWindow() {
    performNavigation(nsMsgNavigationType.previousMessage);
}

function realNextMessage() {
    GoNextMessage(nsMsgNavigationType.nextMessage, false );
}

function realPreviousMessage() {
    GoNextMessage(nsMsgNavigationType.previousMessage, false );
}

function openSMTPSelect() {
    if (popupOn)
        return;

    var watcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
    var e = watcher.getWindowByName("smtp", null);

    if (e) {
        e.focus();
    } else {
        var args = {result: false};
        window.openDialog('chrome://messenger/content/SmtpServerList.xul', 'smtp', 'modal,titlebar,chrome', args);
    }
}

function bSMTPDropInit() {
    var p = document.getElementById("SelectSMTP");
    var e = p.getElementsByTagName("menuitem");
    var smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
    var servers = smtpService.smtpServers;
    var defaultSMTP = smtpService.defaultServer;
    var serverCount = servers.Count();

    var showPort = true;
    var showUsername = false;

	try	{
		if (!bPrefs) 
			bGetPrefs();
	} catch (ex) {}

	try { showPort = bPrefs.getBoolPref("buttons.smtpshowport"); } catch (ex) {}
	try { showUsername = bPrefs.getBoolPref("buttons.smtpshowusername"); } catch (ex) {}

    for (var i = 0; i < serverCount; ++i) {
        var server = servers.QueryElementAt(i, Components.interfaces.nsISmtpServer);
        var myKey = server.key;
        for (var j = 0; j < e.length; ++j) {
            if (myKey == e[j].value) {
                var hostname = server.hostname;

                if (showPort) {
                    if (server.port)
                        hostname += ":" + server.port;
                } else {
                    // check for extra port string
                }

                if (showUsername && server.username != "")
                    hostname += " (" + server.username + ")";

                e[j].label = hostname;

                if (myKey == defaultSMTP.key)
                    e[j].setAttribute("checked", true);

                break;
            }
        }
    }
}

function bSMTPSelectDefault(p) {
    var smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
    if (p.value != smtpService.defaultServer.key) {
        smtpService.defaultServer = smtpService.getServerByKey(p.value);
    }
    popupOn = true;
}

function buttonsDeleteJunk() {
    var enabled = new Object();
    enabled.value = false;
    var checkStatus = new Object();
    if (gDBView)
        gDBView.getCommandStatus(nsMsgViewCommandType.deleteJunk, enabled, checkStatus);

    // Run command if valid
    if (enabled.value) {
        var bypassTrash = 0;

        try	{
            if (!bPrefs) 
                bGetPrefs();
        } catch (ex) {}

        try { bypassTrash = bPrefs.getIntPref("buttons.bypasstrash"); } catch (ex) {}

        if (bypassTrash == 1) {
            var folderTree = GetFolderTree();
            var folderResource = GetFolderResource(folderTree, GetSelectedFolderIndex());
            var specialFolder = GetFolderAttribute(folderTree, folderResource, "SpecialFolder");

            if (specialFolder != "Junk")
                bypassTrash = 0;
        }

        if (bypassTrash == 0) {
            // Delete junk into Trash
            deleteJunkInFolder();
        } else {
            // Delete junk bypassing Trash
            /* Copied from deleteJunkInFolder() in mailCommands.js
               Changed if statements so we don't return out of function
            */
            MsgJunkMailInfo(true);
            var view = GetDBView();

            // need to expand all threads, so we find everything
            view.doCommand(nsMsgViewCommandType.expandAll);

            var treeView = view.QueryInterface(Components.interfaces.nsITreeView);
            var count = treeView.rowCount;
            if (count) {
                var treeSelection = treeView.selection;

                var clearedSelection = false;

                // select the junk messages
                for (var i = 0; i < count; i++) {
                    var messageUri = view.getURIForViewIndex(i);
                    var msgHdr = messenger.messageServiceFromURI(messageUri).messageURIToMsgHdr(messageUri);
                    var junkScore = msgHdr.getStringProperty("junkscore"); 
                    var isJunk = ((junkScore != "") && (junkScore != "0"));
                    // if the message is junk, select it.
                    if (isJunk) {
                      // only do this once
                      if (!clearedSelection) {
                        // clear the current selection
                        // since we will be deleting all selected messages
                        treeSelection.clearSelection();
                        clearedSelection = true;
                        treeSelection.selectEventsSuppressed = true;
                      }
                      treeSelection.rangedSelect(i, i, true /* augment */);
                    }
                }

                // if we didn't clear the selection
                // there was no junk, so bail.
                if (clearedSelection) {
                    treeSelection.selectEventsSuppressed = false;
                    // delete the selected messages
                    //
                    // XXX todo
                    // should we try to set next message after delete 
                    // to the message selected before we did all this, if it was not junk?
                    SetNextMessageAfterDelete();  
                    view.doCommand(nsMsgViewCommandType.deleteNoTrash);
                    treeSelection.clearSelection();
                }
            }
        }
    }
}